SystemOrganization addCategory: #'JMG-RayTracer'!
SystemOrganization addCategory: #'JMG-RayTracer-Geometry'!
SystemOrganization addCategory: #'JMG-RayTracer-Objects'!

Object subclass: #Material
	instanceVariableNames: 'color reflection diffusion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Objects'!

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
color
	^ color.! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
color: aColor 
	color := aColor! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
diffusion
 ^ diffusion! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
diffusion: aFloat
	diffusion := aFloat.! !

!Material methodsFor: 'initialize-release' stamp: 'jmg 3/10/2012 15:49'!
initialize
	super initialize.
	color := Color
				r: 0.2
				g: 0.2
				b: 0.2.
	reflection := 0.
	diffusion := 0.2.
	^ self.! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
reflection
	^ reflection! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:50'!
reflection: aFloat
	reflection := aFloat.! !

!Material methodsFor: 'accessing' stamp: 'jmg 3/10/2012 15:51'!
specularHighlight
	^ 1.0 - diffusion.! !

Object variableSubclass: #Point3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Geometry'!

!Point3 class methodsFor: 'instance creation' stamp: 'jmg 3/9/2012 16:04'!
x: x y: y z: z 
	| point |
	point := Point3 new.
	point setX: x;
		 setY: y;
		 setZ: z.
		^ point.! !

!Point3 methodsFor: 'calculation' stamp: 'jmg 3/10/2012 15:44'!
+ aVector 
	| newPoint |
	newPoint := Point3
				x: self x + aVector x
				y: self y + aVector y
				z: self z + aVector z.
				^ newPoint.! !

!Point3 methodsFor: 'calculation' stamp: 'jmg 3/10/2012 15:45'!
- aPoint 
	| newVector |
	newVector := Vector3
				x: self x - aPoint x
				y: self y - aPoint y
				z: self z - aPoint z.
				^ newVector.! !

!Point3 methodsFor: 'initialize-release' stamp: 'jmg 3/9/2012 16:21'!
initialize
super initialize.
	self at: 1 put: 0.
	self at: 2 put: 0.
	self at: 3 put: 0! !

!Point3 methodsFor: 'private' stamp: 'jmg 3/9/2012 16:19'!
setX: aNumber
	self at: 1 put: aNumber.! !

!Point3 methodsFor: 'private' stamp: 'jmg 3/9/2012 16:19'!
setY: aNumber
	self at: 2 put: aNumber.! !

!Point3 methodsFor: 'private' stamp: 'jmg 3/9/2012 16:20'!
setZ: aNumber
	self at: 3 put: aNumber.! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:19'!
x
	^ self at: 1.! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:19'!
x: aNumber 
	self at: 1 put: aNumber! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:20'!
y
^ self at: 2.! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:19'!
y: aNumber 
	self at: 2 put: aNumber! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:20'!
z
	^ self at: 3.! !

!Point3 methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:20'!
z: aNumber 
	self at: 3 put: aNumber! !

Object subclass: #PrimitiveObject
	instanceVariableNames: 'material name isLight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Objects'!

PrimitiveObject subclass: #Light
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Objects'!

!Light methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:46'!
isLight
	^ true.! !

PrimitiveObject subclass: #Plane
	instanceVariableNames: 'normal d'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Geometry'!

!Plane class methodsFor: 'instance creation' stamp: 'jmg 3/9/2012 15:50'!
normal: aVector d: aNumber 
	| plane |
	plane := self new.
	plane setNormal: aVector.
	plane setD: aNumber.
	^ plane.
	! !

!Plane methodsFor: 'initialize-release' stamp: 'jmg 3/9/2012 16:02'!
initialize
	super initialize.
	normal := Vector3
				x: 0
				y: 0
				z: 0.
	d := 0! !

!Plane methodsFor: 'testing' stamp: 'jmg 1/6/2012 10:47'!
isLight
	^ false.! !

!Plane methodsFor: 'private' stamp: 'jmg 3/9/2012 15:51'!
setD: aNumber
	d := aNumber.! !

!Plane methodsFor: 'private' stamp: 'jmg 3/9/2012 15:50'!
setNormal: aNormal
	normal := aNormal.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:58'!
colorAt: a3DPoint
	self subclassResponsibility .! !

!PrimitiveObject methodsFor: 'initialize-release' stamp: 'jmg 3/10/2012 15:54'!
initialize
	super initialize.
	material := Material new.
	name := ''.
	isLight := false.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:57'!
intersect: aRay at: distance 
	self subclassResponsibility.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 3/10/2012 15:53'!
isLight
^ isLight.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:54'!
material
 material ifNil: [material := Material new.].
	^ material.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:55'!
material: aNewMaterial
	material := aNewMaterial.! !

!PrimitiveObject methodsFor: 'testing' stamp: 'jmg 1/6/2012 10:53'!
name
	name
		ifNil: [name := 'default'].
	^ name copy.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:48'!
name: newName 
	name := newName.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:57'!
normal
	self subclassResponsibility.! !

!PrimitiveObject methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:57'!
normalAt: a3DPoint 
	self subclassResponsibility! !

PrimitiveObject subclass: #Sphere
	instanceVariableNames: 'centre sqRadius radius rRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Objects'!

!Sphere methodsFor: 'as yet unclassified' stamp: 'jmg 3/9/2012 15:39'!
initialize
	centre := Vector3
				x: 0.0
				y: 0.0
				z: 0.0.
	sqRadius := 0.0.
	rRadius := 0.0.
	radius := 0.0! !

!Sphere methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:47'!
isLight
	^ false.! !

Object subclass: #Ray
	instanceVariableNames: 'origin direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Geometry'!

!Ray class methodsFor: 'instance creation' stamp: 'jmg 3/9/2012 15:52'!
origin: aPoint direction: aVector 
	| ray |
	ray := self new.
	ray setOrigin: aPoint.
	ray setDirection: aVector.
	^ ray.! !

!Ray methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:23'!
direction
	^ direction.! !

!Ray methodsFor: 'initialize-release' stamp: 'jmg 3/9/2012 16:22'!
initialize
	super initialize.
	origin := Point3
				x: 0
				y: 0
				z: 0.
	direction := Vector3
				x: 0
				y: 0
				z: 0! !

!Ray methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:23'!
origin
	^ origin.! !

!Ray methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:22'!
setDirection: aVector
	direction := aVector.! !

!Ray methodsFor: 'accessing' stamp: 'jmg 3/9/2012 16:22'!
setOrigin: aPoint
	origin := aPoint.! !

Object subclass: #Scene
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer'!

!Scene methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:44'!
addObjectToScene: aPrimitiveObject 
	objects add: aPrimitiveObject.! !

!Scene methodsFor: 'as yet unclassified' stamp: 'jmg 1/6/2012 10:44'!
initialize
	super initialize.
	objects := OrderedCollection new.! !

Object variableSubclass: #Vector3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Geometry'!

!Vector3 class methodsFor: 'instance creation' stamp: 'jmg 3/9/2012 15:40'!
x: x y: y z: z 
	| vec |
	vec := Vector3 new: 3.
	vec
		x: x
		y: y
		z: z.
	^ vec! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:39'!
* scalar 
	| newVec |
	newVec := Vector3 new: 3.
	scalar isNumber
		ifFalse: [self error: 'Expected a numeric quanity for the scalar value to multiply by. For vectors use dot product.'].
	newVec x: self x * scalar.
	newVec y: self y * scalar.
	newVec z: self z * scalar.
	^ newVec! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:39'!
+ aVec 
	| newVec |
	((aVec isMemberOf: Vector3)
			or: [aVec isSequenceable
					and: [aVec size = 3]])
		ifTrue: [newVec := Vector3 new: 3.
			1
				to: self size
				do: [:index | newVec at: index put: (self at: index)
							+ (aVec at: index)].
			^ newVec]
		ifFalse: [self error: 'Cannot add type to vector']! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:40'!
/ scalar 
	| newVec |
	newVec := Vector3 new: 3.
	newVec x: self x / scalar.
	newVec y: self y / scalar.
	newVec z: self z / scalar.
	^ newVec! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:40'!
crossProduct: aVector 
	| newVector |
	newVector := Vector3 new.
	newVector x: self y * aVector z - (self z - aVector y).
	newVector y: self z * aVector x - (self x * aVector z).
	newVector z: self x * aVector y - (self y * aVector x).
	^ newVector! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 8/10/2011 13:03'!
distanceFrom: aVector
	^ ((self x - aVector x) squared + (self y - aVector y) squared + (self z - aVector z) squared) sqrt.! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:40'!
dot: anotherVector 
	| newVector |
	newVector := Vector3 new.
	newVector x: self x * anotherVector x.
	newVector y: self y * anotherVector y.
	newVector z: self z * anotherVector z.
	^ newVector! !

!Vector3 methodsFor: 'initialize-release' stamp: 'jmg 3/9/2012 16:02'!
initialize
	self at: 1 put: 0.
	self at: 2 put: 0.
	self at: 3 put: 0! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 4/8/2011 09:04'!
magnitude
	| total |
	total := (self x squared) + (self y squared) + (self z squared).
	^ total sqrt.! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 8/10/2011 13:03'!
manhattanDistanceFrom: aVector 
	^ (self x - aVector x) squared + (self y - aVector y) squared + (self z - aVector z) squared! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:44'!
normalized
	| newVector scale |
	newVector := Vector3 new.
	scale := 1.0 / (self x squared + self y square + self z squared) sqrt.
	newVector x: (self x * scale) newVector y: self y * scale.
	newVector z: self z * scale.
	^ newVector! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:40'!
rayWithDirection: anotherVec scaledBy: scalar 
	| newVec |
	newVec := Vector3 new.
	newVec x: self x + (anotherVec x * scalar).
	newVec y: self y + (anotherVec y * scalar).
	newVec x: self z + (anotherVec z * scalar).
	^ newVec! !

!Vector3 methodsFor: 'calculation' stamp: 'jmg 3/9/2012 15:40'!
scale: scaleFactor 
	| newVec |
	newVec := Vector3 new: 3.
	newVec x: self x * scaleFactor.
	newVec y: self y * scaleFactor.
	newVec z: self z * scaleFactor.
	^ newVec! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 08:59'!
x
^ self at: 1.! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 15:27'!
x: x
self at: 1 put: x.! !

!Vector3 methodsFor: 'private' stamp: 'jmg 4/8/2011 15:26'!
x: x y: y z: z 
	self at: 1 put: x.
	self at: 2 put: y.
	self at: 3 put: z.! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 08:59'!
y
^ self at: 2.! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 15:27'!
y: y
self at: 2 put: y.! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 09:00'!
z
	^ self at: 3.! !

!Vector3 methodsFor: 'accessing' stamp: 'jmg 4/8/2011 15:27'!
z: z
self at: 3 put: z.! !

TestCase variableSubclass: #Vector3Test
	instanceVariableNames: 'vec1 vec2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JMG-RayTracer-Geometry'!

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 3/9/2012 15:39'!
setUp
	vec1 := Vector3
				x: 1
				y: 1
				z: 1.
	vec2 := Vector3
				x: 1
				y: 2
				z: 3! !

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 4/8/2011 15:38'!
testAddition
	vec1 := vec1 + vec2.
	self assert: [vec1 x closeTo: 2].
	self assert: [vec1 y closeTo: 3].
	self assert: [vec1 z closeTo: 4].      ! !

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 3/9/2012 15:39'!
testMagnitude
	self
		assert: [vec1 magnitude closeTo: 3 sqrt].
	vec1 := Vector3
				x: 1
				y: 0
				z: 0.
	self
		assert: [vec1 magnitude closeTo: 1]! !

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 4/8/2011 15:44'!
testMultiplication
	vec1 := vec1 * 5.
	self assert: [vec1 x closeTo: 5].  
	self assert: [vec1 y closeTo: 5].
	self assert: [vec1 z closeTo: 5].! !

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 4/8/2011 15:41'!
testRay
	| vec3 |
	vec3 := vec1 + (vec2 * 10).! !

!Vector3Test methodsFor: 'as yet unclassified' stamp: 'jmg 4/8/2011 15:37'!
testScale
	vec1
		x: 1
		y: 1
		z: 1.
	vec1 := vec1 scale: 2.0.
	self
		assert: [vec1 x closeTo: 2].
	self
		assert: [vec1 y closeTo: 2].
	self
		assert: [vec1 z closeTo: 2]! !
